<template>
  <div :class="$style.wrapper">
    <base-card :class="$style.cardWrapper">
      <template #header>
        <base-image
          :imgClass="$style.mainProductImage"
          :class="$style.figureClass"
          soruce="/img/product-images/1.jpg"
          alt="hoodie image"
          lazy-load
        ></base-image>
        <base-spacing y="1.2" metric="rem">
          <base-typography elem-type="h1" type="bold">
            {{ title | capitalize }}
          </base-typography>
        </base-spacing>
      </template>
      <template #main-content>
        <div :class="$style.tagWrapper">
          <base-spacing
            x="0.2"
            metric="rem"
            v-for="category in categories"
            :key="category.id"
          >
            <base-tag theme="primary"> {{ category.name }}</base-tag>
          </base-spacing>
        </div>
        <div :class="$style.descWrapper">
          <base-spacing x="0.2" y="0.5" metric="rem">
            <base-typography color="gray" font-size="0.8rem" type="regular">
              {{ description }}
            </base-typography>
          </base-spacing>
        </div>
        <base-spacing x="0.2" y="0.5" metric="rem">
          <div :class="$style.dateWrapper">
            <base-typography color="gray" font-size="0.8rem" type="regular">
              <span>Founded</span> <span>:</span>
            </base-typography>

            <base-typography color="gray" font-size="0.8rem" type="bold">
              {{ date | timeStampToYearFilter }}
            </base-typography>
          </div>
        </base-spacing>
        <base-spacing x="0.2" top="1.5" bottom="0.5" metric="rem">
          <base-button theme="primary" @click="handleAddToCart">
            Add to Cart
          </base-button>
        </base-spacing>
      </template>
    </base-card>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { mapMutations } from "vuex";
import MutationTypes from "@/store/modules/cart/mutation-types";

// components
import BaseSpacing from "@/components/base/BaseSpacing/index.vue";
import BaseTypography from "@/components/base/BaseTypography/index.vue";
import BaseCard from "@/components/base/BaseCard/index.vue";
import BaseImage from "@/components/base/BaseImage/index.vue";
import BaseTag from "@/components/base/BaseTag/index.vue";
import BaseButton from "@/components/base/BaseButton/index.vue";

// filters
import timeStampToYearFilter from "@/filters/timeStampToYear";

export default Vue.extend({
  name: "ProductItem",
  components: {
    BaseCard,
    BaseImage,
    BaseSpacing,
    BaseTypography,
    BaseTag,
    BaseButton
  },
  filters: {
    timeStampToYearFilter
  },
  props: {
    title: {
      type: String,
      required: true
    },
    categories: {
      type: Array,
      required: false
    },
    description: {
      type: String,
      required: false
    },
    image: {
      type: String,
      required: false
    },
    id: {
      type: Number,
      required: false
    },
    date: {
      type: Number,
      required: false
    }
  },
  methods: {
    ...mapMutations({
      addToCart: `cart/${MutationTypes.ADD_NEW_ITEM_TO_CART}`
    }),
    handleAddToCart: function() {
      this.addToCart({ id: this.id, quantity: 1 });
      this.$router.push("/cart");
    }
  }
});
</script>

<style module lang="scss">
.wrapper {
  composes: display--flex;
  composes: flex-direction--column;
  composes: align-items--center;
  composes: justify-content--center;
  max-width: 800px;
}
.cardWrapper {
  max-width: 400px;
  width: 400px;
}
.figureClass {
  max-width: 400px;
  transition: transform 0.3s;
}
.mainProductImage {
  width: 100%;
  composes: border-radius--default;
}
.tagWrapper {
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--start;
  composes: margin-t-b--default;
}

.dateWrapper {
  composes: display--flex;
}

@media screen and (max-width: $device-size--mobile-large) {
  .cardWrapper {
    width: 100%;
  }
  .wrapper {
    max-width: 100%;
    > div:first-child {
      margin-right: 0 !important;
      margin-left: 0 !important;
      margin-bottom: 15px;
    }
  }
}
</style>
